package core.notevault.data;

import androidx.room.Entity;
import androidx.room.PrimaryKey;
import core.notevault.data.sync.SyncStatus;

@Entity(tableName = "note_sheets")
public class NoteSheet {

    @PrimaryKey(autoGenerate = true)
    private int id;
    private SyncStatus syncStatus;
    private long musicNoteId;
    private String filePath;

    public NoteSheet(long musicNoteID, String filePath) {
        this.musicNoteId = musicNoteID;
        this.filePath = filePath;
        this.syncStatus = SyncStatus.CREATED;
    }

    public NoteSheet() {
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public long getMusicNoteId() {
        return musicNoteId;
    }

    public void setMusicNoteId(long musicNoteId) {
        this.musicNoteId = musicNoteId;
    }

    public String getFilePath() {
        return filePath;
    }

    public void setFilePath(String filePath) {
        this.filePath = filePath;
    }

    public SyncStatus getSyncStatus() {
        return syncStatus;
    }

    public void setSyncStatus(SyncStatus syncStatus) {
        this.syncStatus = syncStatus;
    }
}
